/* @(#)example.dsc	4.3 2/2/93 10:59:37 */

/* Gettings Started example for custom disassembler */

%% DEF
int  p;

%% EQU
LT:  Opcode, CheckMr, CheckMw, CheckR   /* lookup tables */
IT:  R, C, V                            /* index tables  */

%% FORMAT

logo: "CDISA80 Example"

head: "CDISA80 Example"  26

Pods: threshold = {{TTL, TTL},
                   {TTL, TTL}
                  }

clock: clk = { name = "CLK",
               edge = rising,
               channel = 31,
               qualifier = { channels = { 30 },
                             levels = { high }
                           }
             }

label: QUAL =  { name = "QUAL",
                 display = timing,
                 channels = { 30 }
               }

label: RWN =  { name = "R/WN",
                channels = { 24 }
               }

label: OPCDN ={ name = "OPC/DN",
                channels = { 25 }
               }


label: ADDRESS = {  name = "ADDRESS",
                    channels = { 15, 14, 13, 12, 11, 10, 9, 8,
                                  7,  6,  5,  4,  3,  2, 1, 0 }
                 }

label: DATA =  { name = "DATA",
                 channels = { 23, 22, 21, 20, 19, 18, 17, 16 }
               }


clockseq: SEQ = { clk }


%% START

! Opcode !

%% Opcode

(OPCDN = 0b1, DATA = 0x0[.]) ! "LOAD   A," {p=$1} CheckR  !
(OPCDN = 0b1, DATA = 0x1[.]) ! "LOAD   "   R[$1] "," NEXT V[0]!
(OPCDN = 0b1, DATA = 0x2[.]) ! "LOAD   "   R[$1] "," NEXT V[1] NEXT CheckMr !
(OPCDN = 0b1, DATA = 0x3[.]) ! "STORE  "   R[$1] "," NEXT V[1] NEXT CheckMw !
(OPCDN = 0b1, DATA = 0x4[.]) ! "ADD    A," {p=$1} CheckR  !
(OPCDN = 0b1, DATA = 0x7[.]) ! "DECR   "   {p=$1} CheckR  !
(OPCDN = 0b1, DATA = 0xF[.]) ! "JUMP   "   C[$1] NEXT V[1]!


%% CheckMw

(OPCDN = 0b0, RWN = 0b0)     ! mw !


%% CheckMr

(OPCDN = 0b0, RWN = 0b1)     ! mr !


%% CheckR

(p > 0)  ! R[p] !

%% R

! "A"  !
! "R1" !
! "R2" !
! "R3" !
! "R4" !

%% C

! ""    !
! "Z,"  !
! "NZ," !

%% V

(DATA = 0x[..])     ! prog "%02x" !
(DATA = 0x[..])     ! prog "%02x" NEXT V[0] !

